#include <Arduino.h>
#include <PID_v1.h>
#include "esp32-hal-cpu.h"

#define MEC_TOL 10

#define TIME_PID 130

#define PID_TOL  10
#define TIME_PIDTol 10

#define TIME_LIMITS 20
#define PWM_LIMITS 60


    const int encoderA = 32;
    const int encoderB = 33;

    const int control1 = 14;
    const int control2 = 25;

  
    const int PWM = 26;
    const int buttonPin = 8;

    double position0 = 0;
    double posEndtimeLimit = 0;

 

    double OutputPWM, Setpoint;
    int SampleTime = 1;


 void countingInterruptionA();
 void countingInterruptionB();
 void adelante();
 void atras();
 void limitesTiempo();
 void pidPWM(double);
 void arriba();
 void abajo();

PID myPID(&position0, &OutputPWM, &Setpoint,3,5,1, DIRECT);

void setup() {
  Serial.begin(9600);


  pinMode(buttonPin, INPUT_PULLUP);
  pinMode(13, OUTPUT);
  
  pinMode(encoderA, INPUT_PULLUP);
  pinMode(encoderB, INPUT_PULLUP);

  pinMode(control1, OUTPUT);
  pinMode(control2, OUTPUT);
  pinMode(PWM, OUTPUT);
  ledcSetup(0, 490, 8);
  ledcAttachPin(PWM, 0);
  
  attachInterrupt(digitalPinToInterrupt(encoderA), countingInterruptionA, CHANGE );
  attachInterrupt(digitalPinToInterrupt(encoderB), countingInterruptionB, CHANGE );

  myPID.SetSampleTime(SampleTime);
  myPID.SetMode(AUTOMATIC);
  myPID.SetOutputLimits(-200, 200);
  limitesTiempo();
  Serial.println(position0);
}

void loop() {
   delay(1000);
  limitesTiempo();
  Serial.println(position0);
// arriba();
//  Serial.println(position0);
// delay(1000);
// abajo();
//  Serial.println(position0);
// delay(1000);
// if (digitalRead(buttonPin) == HIGH)
// {
//   arriba();
//   digitalWrite(13, HIGH);
// }else
// {
//   abajo();
//   digitalWrite(13, LOW);
// }


// pidPWM(posEndtimeLimit/2);
// Serial.println(position0);

  }
void pidPWM(double setPosition)
{
  
   Setpoint = setPosition;
  // double previousPos = 0;

    bool limitFlag = LOW;
    unsigned long currentTime = 0;
    unsigned long previousTime = 0;
    const long timeforLimit = TIME_PID;

    unsigned long currentTimePIDTol = 0;
    unsigned long previousTimePIDTol = 0;
    const long timeforLimitPIDTol = TIME_PIDTol;
    
if (Setpoint < posEndtimeLimit  && Setpoint > 0)
{
            while (limitFlag != HIGH)
          {
            currentTime = micros();

            // myPID.Compute();
            //   if(OutputPWM < 0){
            //     atras();
            //     }else if (OutputPWM >= 0) {
            //       adelante();
            //     }

            // analogWrite(PWM, abs(OutputPWM));

                    if (currentTime - previousTime >=  timeforLimit)
                    {
                        previousTime = currentTime;
                          myPID.Compute();
                        if(OutputPWM < 0){
                          atras();
                          }else if (OutputPWM >= 0) {
                            adelante();
                          }

                      ledcWrite(0, abs(OutputPWM));

                            // if ( (Setpoint - PID_TOL ) <= position0 && (Setpoint + PID_TOL) >= position0 )
                            //               {
                            //                 limitFlag = HIGH;
                            //               }
                      }

                      currentTimePIDTol = millis();
                    if (currentTimePIDTol - previousTimePIDTol >=  timeforLimitPIDTol)
                    {
                            if ( (Setpoint - PID_TOL ) <= position0 && (Setpoint + PID_TOL) >= position0 )
                                          {
                                            limitFlag = HIGH;
                                          }
                      }
          }
ledcWrite(0, 0);
}
else
{
  Serial.println("POS ERROR");
}

} 

void limitesTiempo()
 {
    bool limitFlag = LOW;
    unsigned long currentTime = 0;
    unsigned long previousTime = 0;
    const long timeforLimit = TIME_LIMITS;

  atras();
while (limitFlag != HIGH)
{
  currentTime = millis();
  ledcWrite(0,PWM_LIMITS);

 if (currentTime - previousTime >=  timeforLimit)
 {
    previousTime = currentTime;

              if (position0 == posEndtimeLimit)
              {
                limitFlag = HIGH;
              }
          
      posEndtimeLimit = position0;
 
 }
}
  ledcWrite(0, 0);
  adelante();
  limitFlag = LOW;
  position0 = 0;
  posEndtimeLimit = 0;

while (limitFlag != HIGH)
{
  currentTime = millis();
  ledcWrite(0,PWM_LIMITS);

 if (currentTime - previousTime >=  timeforLimit)
 {
    previousTime = currentTime;

              if (position0 == posEndtimeLimit)
              {
                limitFlag = HIGH;
              }
          
      posEndtimeLimit = position0;
 
 }
}
ledcWrite(0, 0);
limitFlag = LOW;
}

void countingInterruptionA(){
      int MSB = digitalRead(encoderA); 
    int LSB = digitalRead(encoderB); 
    if (MSB == HIGH) {
        if (LSB == HIGH) {
            position0++;
        }
        if (LSB == LOW) {
            position0--;
        }
    }
    if (MSB == LOW) {
        if (LSB == HIGH) {
            position0--;
        }
        if (LSB == LOW) {
            position0++;
        }
    }
}

void countingInterruptionB(){
      int MSB = digitalRead(encoderA); 
    int LSB = digitalRead(encoderB); 
    if (LSB == HIGH) {
        if (MSB == LOW) {
            position0++;
        }
        if (MSB == HIGH) {
            position0--;
        }
    }
    if (LSB == LOW) {
        if (MSB == LOW) {
            position0--;
        }
        if (MSB == HIGH) {
            position0++;
        }
    }
}

void adelante()
{
  digitalWrite(control1, LOW);
  digitalWrite(control2, HIGH);
}

void atras()
{
  digitalWrite(control1, HIGH);
  digitalWrite(control2, LOW);
}

void arriba()
{
pidPWM((posEndtimeLimit - MEC_TOL));
Serial.println(position0);
}
void abajo()
{
  pidPWM(posEndtimeLimit - posEndtimeLimit + MEC_TOL);
Serial.println(position0);
}